﻿#region Copyright Syncfusion Inc. 2001 - 2015
// Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
// Use of this code is subject to the terms of our license.
// A copy of the current license can be obtained at any time by e-mailing
// licensing@syncfusion.com. Any infringement will be prosecuted under
// applicable laws. 
#endregion
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Syncfusion.Windows.Shared;
using System.ComponentModel;
using Syncfusion.Windows.Controls.Grid;
using System.IO;
using Syncfusion.UI.Xaml.Grid;

namespace ComplexPropertyBindingDemo
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.sfdatagrid.AutoGeneratingColumn += Sfdatagrid_AutoGeneratingColumn;
        }
        private void Sfdatagrid_AutoGeneratingColumn(object sender, Syncfusion.UI.Xaml.Grid.AutoGeneratingColumnArgs e)
        {
            if (e.Column.MappingName == "Customers.CompanyName")
            {
                #region CellTemplate

                GridTemplateColumn col1 = new GridTemplateColumn();
                FrameworkElementFactory factory1 = new FrameworkElementFactory(typeof(TextBlock));
                Binding b1 = new Binding("Customers.CompanyName");
                b1.Mode = BindingMode.TwoWay;
                factory1.SetValue(TextBlock.TextProperty, b1);
                DataTemplate cellTemplate1 = new DataTemplate();
                cellTemplate1.VisualTree = factory1;
                col1.CellTemplate = cellTemplate1;
                sfdatagrid.Columns.Add(e.Column);

                #endregion

                #region EditTemplate

                GridTemplateColumn col2 = new GridTemplateColumn();
                FrameworkElementFactory factory12 = new FrameworkElementFactory(typeof(TextBox));
                Binding b12 = new Binding("Customers.CompanyName");
                b12.Mode = BindingMode.TwoWay;
                factory12.SetValue(TextBox.TextProperty, b12);
                DataTemplate cellTemplate12 = new DataTemplate();
                cellTemplate12.VisualTree = factory12;
                col2.EditTemplate = cellTemplate12;
                sfdatagrid.Columns.Add(e.Column);

                #endregion

                e.Column = new GridTemplateColumn()
                {
                    MappingName = "Customers.CompanyName",
                    HeaderText = "CompanyName",
                    ColumnSizer = GridLengthUnitType.Auto,
                    AllowResizing = true,
                    CellTemplate = cellTemplate1,
                    EditTemplate = cellTemplate12
                };
            }
        }
    }
}
